unit BotCPU;
interface
uses BotUnit, Graphics, SysUtils, Monstr;

var
  lastVisible  : boolean = false;
  lastAudible : boolean = false;

type

//,  

  TCPUPlayer = class(TPlayer)
  private
    ndx    : integer;
    Monstr : TMonstr;                            // ""
  public
    procedure onKilled; override;                //   
    procedure onHit; override;                   //    
    procedure onOtherPlayerKilled(); override;   //   ,
                                                 // 
    procedure onOtherPlayerFired(); override;    //   ,
                                                 // 
    constructor Create;                          //
    function Name(): string; override;           //  
    function OtherPlayerAudible: boolean;        //,   
                                                 //   
                                                 //
    function OtherPlayerVisible: boolean;        //,  
                                                 //   
                                                 //
    procedure Update(); override;                // 
                                                 // 
  end;

implementation
uses BotDemo;

constructor TCPUPlayer.Create;
var
  i: integer;
begin
  inherited;
  ndx:=objectCounter;
  inc(objectCounter);
  fRadius:=pWidth;
  fColor:=clLime;
  GeneratePosition();

  for i := 0 to high(Objects) do
    if Objects[i] <> nil then
      if Objects[i] is THumanPlayer then
      begin
        Monstr := TMonstr.Create(self, Objects[i]);
        break;
      end;

  search := 0;
end;

//,        

function TCPUPlayer.OtherPlayerAudible: boolean;
var
  i: integer;
begin
  result:=false;
  for i := 0 to high(Objects) do
    if (Objects[i] <> nil) and (Objects[i] is TPlayer) and (Objects[i] <> self) then
    begin
      result:=result or (sqrt(sqr(objects[i].xPosition-xPos)+sqr(objects[i].yPosition-yPos)) < 60);
    end;
end;

//,       

function TCPUPlayer.OtherPlayerVisible: boolean;
var
  i: integer;
  rx,ry,a,b,c: double;
  ok1,ok2: boolean;
begin
  result:=false;
  for i := 0 to high(Objects) do
    if (Objects[i] <> nil) and (Objects[i] is TPlayer) and (Objects[i] <> self) then
    begin
      rx:=objects[i].xPosition;
      ry:=objects[i].yPosition;
      a:=cos((dir-8)*cor);
      b:=sin((dir-8)*cor);
      c:=-a*xPos-b*yPos;
      ok1:=a*rx+b*ry+c > 0;
      a:=cos((dir+8)*cor);
      b:=sin((dir+8)*cor);
      c:=-a*xPos-b*yPos;
      ok2:=a*rx+b*ry+c > 0;
      result:=result or (ok1 and ok2);
    end;
end;

//  

function TCPUPlayer.Name(): string;
begin
  result:=''+inttostr(ndx);
end;

//   

procedure TCPUPlayer.onKilled;
begin
  Monstr.Run(7);
  lastVisible  := false;
  lastAudible  := false;
end;

//    

procedure TCPUPlayer.onHit;
begin
  Monstr.Run(2);
end;

//   ,  

procedure TCPUPlayer.onOtherPlayerKilled();
begin
  Monstr.Run(6);
  lastVisible  := false;
  lastAudible  := false;
end;

//   ,  

procedure TCPUPlayer.onOtherPlayerFired();
begin
  Monstr.Run(1);
end;

//   

procedure TCPUPlayer.Update();
begin
  if Monstr.state = 2 then
    Monstr.Attack.Run(1024);

  if (search> 0) then
  begin
    if Monstr.attack.turnLeft then
      doLeft()
    else
      doRight();
    dec(search);
  end;

  inc(toFire);

  if OtherPlayerVisible and (not lastVisible) then
  begin
    search := 0;
    lastVisible := true;
    Monstr.Run(3);
  end
  else if (not OtherPlayerVisible) and lastVisible then
  begin
    lastVisible := false;
    Monstr.Run(5);
  end;

  if OtherPlayerAudible and (not OtherPlayerVisible) and (not lastAudible) then
    Monstr.Run(1);
  lastAudible := OtherPlayerAudible;

  CheckColission()
end;

end.

